% declare type for possible worlds
thf(mworld_type,type,(
    mworld: $tType )).

% declare accessibility relations
thf(mrel_type,type,(
    mrel: mworld > mworld > $o )).

% define accessibility relation properties
thf(mreflexive_type,type,(
    mreflexive: ( mworld > mworld > $o ) > $o )).

thf(mreflexive_def,definition,
    ( mreflexive
    = ( ^ [R: mworld > mworld > $o] :
        ! [A: mworld] :
          ( R @ A @ A ) ) )).

thf(meuclidean_type,type,(
    meuclidean: ( mworld > mworld > $o ) > $o )).

thf(meuclidean_def,definition,
    ( meuclidean
    = ( ^ [R: mworld > mworld > $o] :
        ! [A: mworld,B: mworld,C: mworld] :
          ( ( ( R @ A @ B )
            & ( R @ A @ C ) )
         => ( R @ B @ C ) ) ) )).

% assign properties to accessibility relations
thf(mrel_mreflexive,axiom,(
    mreflexive @ mrel )).

thf(mrel_meuclidean,axiom,(
    meuclidean @ mrel )).

% define valid operator
thf(mvalid_type,type,(
    mvalid: ( mworld > $o ) > $o )).

thf(mvalid_def,definition,
    ( mvalid
    = ( ^ [S: mworld > $o] :
        ! [W: mworld] :
          ( S @ W ) ) )).

% define nullary, unary and binary connectives which are no quantifiers
thf(mimplies_type,type,(
    mimplies: ( mworld > $o ) > ( mworld > $o ) > mworld > $o )).

thf(mimplies,definition,
    ( mimplies
    = ( ^ [A: mworld > $o,B: mworld > $o,W: mworld] :
          ( ( A @ W )
         => ( B @ W ) ) ) )).

thf(mdia_type,type,(
    mdia: ( mworld > $o ) > mworld > $o )).

thf(mdia_def,definition,
    ( mdia
    = ( ^ [A: mworld > $o,W: mworld] :
        ? [V: mworld] :
          ( ( mrel @ W @ V )
          & ( A @ V ) ) ) )).

thf(mbox_type,type,(
    mbox: ( mworld > $o ) > mworld > $o )).

thf(mbox_def,definition,
    ( mbox
    = ( ^ [A: mworld > $o,W: mworld] :
        ! [V: mworld] :
          ( ( mrel @ W @ V )
         => ( A @ V ) ) ) )).

% define exists quantifiers
thf(mexists_const_type__o__d_i_t__d_i_c_,type,(
    mexists_const__o__d_i_t__d_i_c_: ( ( $i > $i ) > mworld > $o ) > mworld > $o )).

thf(mexists_const__o__d_i_t__d_i_c_,definition,
    ( mexists_const__o__d_i_t__d_i_c_
    = ( ^ [A: ( $i > $i ) > mworld > $o,W: mworld] :
        ? [X: $i > $i] :
          ( A @ X @ W ) ) )).

% define for all quantifiers
thf(mforall_const_type__o__d_i_t__o_mworld_t__d_o_c__c_,type,(
    mforall_const__o__d_i_t__o_mworld_t__d_o_c__c_: ( ( $i > mworld > $o ) > mworld > $o ) > mworld > $o )).

thf(mforall_const__o__d_i_t__o_mworld_t__d_o_c__c_,definition,
    ( mforall_const__o__d_i_t__o_mworld_t__d_o_c__c_
    = ( ^ [A: ( $i > mworld > $o ) > mworld > $o,W: mworld] :
        ! [X: $i > mworld > $o] :
          ( A @ X @ W ) ) )).

thf(mforall_const_type__o__d_i_c_,type,(
    mforall_const__o__d_i_c_: ( $i > mworld > $o ) > mworld > $o )).

thf(mforall_const__o__d_i_c_,definition,
    ( mforall_const__o__d_i_c_
    = ( ^ [A: $i > mworld > $o,W: mworld] :
        ! [X: $i] :
          ( A @ X @ W ) ) )).

thf(mforall_const_type__o__d_i_t__d_i_c_,type,(
    mforall_const__o__d_i_t__d_i_c_: ( ( $i > $i ) > mworld > $o ) > mworld > $o )).

thf(mforall_const__o__d_i_t__d_i_c_,definition,
    ( mforall_const__o__d_i_t__d_i_c_
    = ( ^ [A: ( $i > $i ) > mworld > $o,W: mworld] :
        ! [X: $i > $i] :
          ( A @ X @ W ) ) )).


% transformed problem
thf(1,conjecture,
    ( mvalid
    @ ( mforall_const__o__d_i_t__o_mworld_t__d_o_c__c_
      @ ^ [P: $i > mworld > $o] :
          ( mforall_const__o__d_i_t__d_i_c_
          @ ^ [F: $i > $i] :
              ( mforall_const__o__d_i_c_
              @ ^ [X: $i] :
                  ( mexists_const__o__d_i_t__d_i_c_
                  @ ^ [Q: $i > $i] :
                      ( mimplies @ ( mdia @ ( mbox @ ( P @ ( F @ X ) ) ) ) @ ( mbox @ ( P @ ( Q @ X ) ) ) ) ) ) ) ) )).
